#!/usr/bin/perl -I/usr/sausalito/handlers/base/appleshare -I/usr/sausalito/perl

package appleshare;

use Sauce::Config;

sub atalk_getscript
{
    return '/etc/rc.d/init.d/atalk';
}

sub atalk_getconf
{
    return '/etc/atalk/AppleVolumes.system';
}

sub atalk_getnetatalk
{
    return '/etc/atalk/netatalk.conf';
}

sub share_comment
{
    my ($when, $group) = @_;

    return "\# $group $when -- do not edit this line";
}

sub share_block
{
    my ($group, $restrict) = @_;
    my $groupdir = Sauce::Config::groupdir_base;
    $restrict = $restrict ? "	allow:\@${group}" : '';
    return "$groupdir/$group    \"$group\"$restrict\n";
}

# edit AppleVolumes. this wipes out any current block. it adds in a new
# one if desired.
sub edit_group
{
    my ($input, $output, $ogroup, $ngroup, $restrict) = @_;
    my ($inblock, $found);

    # search for cobalt part
    while (<$input>) {
	print $output $_;
	if (/^# Cobalt config start/) {
	    $found = 1;
	    last;
	}
    }

    return -1 unless $found;

    my $end = share_comment('end', $ogroup);
    my $begin = share_comment('begin', $ogroup);
    $begin =~ /^$begin/;
    $end =~ /^$end/;
    while (<$input>) {
	if ($inblock) {
	    if ($_ =~ $end) {
		$inblock = 0;
	    }
	    next;
	}

	# look for for the beginning of the appropriate block 
	if ($_ =~ $begin) {
	    $inblock = 1;
	    next;
	}

	# print out the group unless it doesn't exist anymore
	if ((/^# Cobalt config stop/) and $ngroup) {
	    print $output share_comment('begin', $ngroup) . "\n";
	    print $output share_block($ngroup, $restrict);
	    print $output share_comment('end', $ngroup) . "\n";
	}
	
	print $output $_;
    }

    return 0;
}
1;
