#!/usr/bin/perl -I/usr/sausalito/handlers/base/appleshare -I/usr/sausalito/perl
#
# Copyright(c) 2000, Cobalt Networks, Inc.
# Author: asun@cobalt.com
#
# handle guest shares
use Sauce::Config;
use Sauce::Util;
use Sauce::Service;
use CCE;
use appleshare;

my $cce = new CCE(Namespace => 'FileShare');
$cce->connectfd(\*STDIN, \*STDOUT);

my $obj = $cce->event_object();
my $old = $cce->event_old();

my (%settings, $err);

$settings{'AFPD_UAMLIST'} = '"-U uams_clrtxt.so,uams_dhx.so';
$settings{'AFPD_UAMLIST'} .= ',uams_guest.so' if $obj->{guestEnabled};
$settings{'AFPD_UAMLIST'} .= "\"";
$settings{'AFPD_GUEST'} = $obj->{guestUser};

$err = Sauce::Util::editfile(appleshare::atalk_getnetatalk,
			     *Sauce::Util::keyvalue_edit_fcn, 
			     '#', '=', undef, %settings);
if ($err) {
    $cce->bye('FAIL', '[[base-appleshare.cantToggleSetting]]');
    exit 1;
}

# if appleshare is enabled, restart it. we don't care if we can't
# get the right object
my @oids = $cce->find('System');
my ($ok, $aobj) = $cce->get($oids[0], 'AppleShare');
Sauce::Service::service_run_init('atalk', 'restart') if $aobj->{enabled}; 
$cce->bye('SUCCESS');
exit 0;
