#!/usr/bin/perl -I/usr/sausalito/handlers/base/appleshare -I/usr/sausalito/perl
#
# Copyright(c) 2000, Cobalt Networks, Inc.
# Author: asun@cobalt.com
#
use Sauce::Config;
use Sauce::Util;
use Sauce::Service;
use CCE;
use appleshare;

my $cce = new CCE;
$cce->connectfd(\*STDIN, \*STDOUT);

my $obj = $cce->event_object();
my $old = $cce->event_old();

# make sure that the Network Trash Folder is there with the right
# permissions
my $dir = Sauce::Config::groupdir_base . '/' . $obj->{name};
unless (-d $dir) {
    $cce->bye('DEFER');
#    exit 0; 
}
$dir .= '/Network Trash Folder';

my $perms = Sauce::Config::perm_GroupDir();
mkdir($dir, $perms);
chmod($perms, $dir);
chown(Sauce::Config::groupdir_owner(), -1, $dir);

# get the guest workgroup
my @oids = $cce->find('System');
my ($ok, $aobj) = $cce->get($oids[0], 'FileShare');
my $restrict = ($aobj->{name} eq $obj->{name}) ? 0 : 1;

my $err = Sauce::Util::editfile(appleshare::atalk_getconf, 
				*appleshare::edit_group, 
				$old->{name}, $obj->{name}, $restrict);
if ($err) {
	$cce->bye('FAIL', '[base-appleshare.cantModifyGroup]');
	exit 1;
}

my ($aok, $atalk) = $cce->get($oids[0], 'AppleShare');
Sauce::Service::service_run_init('atalk', 'reload') if ($atalk->{enabled});

$cce->bye('SUCCESS');
exit 0;
