#!/usr/bin/perl -I/usr/sausalito/handlers/base/appleshare -I/usr/sausalito/perl
#
# Copyright(c) 2000, Cobalt Networks, Inc.
# Author: asun@cobalt.com
#
use CCE;
use Sauce::Service;
use appleshare;

my $cce = new CCE(Namespace => 'AppleShare');
$cce->connectfd(\*STDIN, \*STDOUT);

my $obj = $cce->event_object();
my $old = $cce->event_old();

my %settings;

# maximum number of users. right now, we always set this even 
# if just the service is getting toggled.
$settings{'AFPD_MAX_CLIENTS'} = $obj->{maxConnections};

# enabled
#if ($old->{enabled} ne $obj->{enabled}) {
#    $settings{'AFPD_RUN'} = $obj->{enabled} ? 'yes' : 'no';
#}

if (%settings) {
    my $err = Sauce::Util::editfile(appleshare::atalk_getnetatalk, 
				    *Sauce::Util::keyvalue_edit_fcn,
				    '#', '=', undef, %settings);
    if ($err) {
	$cce->bye('FAIL', '[[base-appleshare.cantConfigFile]]');
	exit 1;
    }
}
    
# only restart if atalk was running before or was just enabled
Sauce::Service::service_toggle_init('atalk', $obj->{enabled});
$cce->bye('SUCCESS');
exit 0;
